"""Intergration tests for httpslogin.
"""

import os, sys

import glob
from zope.testing import doctest, doctestunit
import unittest
from Globals import package_home
from Testing.ZopeTestCase import ZopeDocTestSuite
import Products
from Products.Five import zcml
from Products.PloneTestCase import PloneTestCase

# Take care of dependencies and load zcml.
PloneTestCase.installProduct('httpslogin')
PloneTestCase.installProduct('SessionCrumbler')

ZCMLS = (
    Products.httpslogin,
    )

for package in ZCMLS:
    zcml.load_config('configure.zcml', package=package)
PloneTestCase.setupPloneSite(extension_profiles=('httpslogin:default',))


def test_setup():
    """
    A view is available:
    
      >>> view = self.portal.restrictedTraverse('@@login_form_view')
      >>> view.__name__
      u'login_form_view'

    The cookie crumbler is replaced:

      >>> crumbler = self.portal.cookie_authentication
      >>> crumbler.meta_type
      'Session Crumbler'

    Note that the crumbler will stay in place on reinstall:

      >>> from Products.httpslogin import setuphandlers
      >>> setuphandlers.replaceCookieAuthentication(self.portal)
      >>> crumbler.aq_base is self.portal.cookie_authentication.aq_base
      True

    Let's make sure that our layer is in all available skins and on
    top of the list:

      >>> for skin, layers in portal.portal_skins.selections.items():
      ...     layers.startswith('custom,httpslogin')
      True
      True
    """

def test_suite():
    return unittest.TestSuite((
        doctestunit.DocTestSuite(module='Products.httpslogin.browser'),
        ZopeDocTestSuite(test_class=PloneTestCase.PloneTestCase),

        ))
